# fmlib.pl - File Manager subroutines
# This file is part of WebRSH 1.1b (beta)
# Copyright (C) 1997,1998  Yoram Last (ylast@mindless.com)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

if ($Win32) {
  require "$ProgDir/lib/fslib-win32.pl" ||
    &WebrshDie("Can\'t require fflib-win32\.pl \: $!");
} else {
  require "$ProgDir/lib/fslib-unix.pl" ||
    &WebrshDie("Can\'t require fflib-unix\.pl \: $!");
};

sub DoFMCom { # Handles file-manager commands.

  local($fmcom,$file,$clnch,$cdel,$csav,$pcntr,$newname,$overwrite,$clpcln) = 
    ($input{'fmcom'},$input{'file'},$input{'clnch'},$input{'cdel'},$input{'csav'},
      $input{'pcntr'},$input{'newname'},$input{'overwrite'},$input{'clpcln'});
  $fmcom =~ s/\s//g;
  if ($fmcom eq 'Edit')  {
    require "$ProgDir/lib/edlib.pl" ||
      &WebrshDie("Can\'t require edlib\.pl \: $!");
    &DoEditCom($file,'');
  } elsif ($fmcom eq 'Upload') {
    if ($file && -d $file) {
        &ChangeDir($file) ||
          &WebrshDie("Can\'t change working directory to $file \: $!");
    }; 
    $fmUpload = 1;
  } elsif ($fmcom eq 'Properties') {
    $fmProps = &GetInfo($file);
  } elsif ($fmcom eq 'Apply' && $input{'props'}) {
    $fmProps = &GetInfo($file);
    &SetAttributes($file,$input{'atA'},$input{'atS'},$input{'atH'},$input{'atR'});
  } elsif ($fmcom eq 'OK' && $input{'props'}) {
    &SetAttributes($file,$input{'atA'},$input{'atS'},$input{'atH'},$input{'atR'});
  } elsif ($fmcom eq 'New') {
    if ($input{'cnew'}) {
      &WebrshDie("This form had expired\!") unless ($pcntr == $counter - 1);
      if (-e $newname) {
        &PromptNew(1,$input{'nftype'},$newname);
      } else {
        &GetUmask if ($OStype eq 'U');
        if ($input{'nftype'} eq 'File') {
          if (open(FILE, ">$newname")) {
            close(FILE);
            $output = "The file $newname had been created.";
          } else {
            $output = "Can\'t create $newname \: $!";
          };
        } else {
          if (&MakeDir($newname)) {
            $output = "The directory $newname had been created.";
          } else {
            $output = "Can\'t create $newname \: $!";
          };
        };
      };
    } else {
      &PromptNew(0,'Directory',&FullPath($pwd,'New')) unless ($pcntr);
    };
  } elsif ($input{'fmcancel'} && $clpcln) {
    $clip = '';
  } elsif ($file) {
    if (-d $file) {$ftype = 'directory';} else {$ftype = 'file';};
    if ($fmcom eq 'Open/Get') {
      if ($ftype eq 'directory') {
        &ChangeDir($file) || &WebrshDie("Can\'t change working directory to $file \: $!"); 
      } else {
        &SendFile($file);
        $done = 1;
#        if ($clnch) {
#          &WebrshDie("This form had expired\!") unless ($pcntr == $counter - 1);
#          &RshStart($file);
#          $output = join(' ','The file',&FullPath($pwd,$file),'had been launched!');
#        } else {
#          &PromptLaunch($file) unless ($pcntr);
#        };
      };
    } elsif ($file ne '..') {
      if ($fmcom eq 'Delete') {
        if ($cdel) {
          &WebrshDie("This form had expired\!") unless ($pcntr == $counter - 1);
          if (&DelTree(&FullPath($pwd,$file))) {
              $output = "The $ftype $file had been deleted\!";
          };
        } else {
          &PromptDel($file,$ftype) unless ($pcntr);
        };
      } elsif ($fmcom eq 'Rename') {
        if ($csav) {
          &WebrshDie("This form had expired\!") unless ($pcntr == $counter - 1);
          if (&RenameFile($file,$newname,$overwrite,$clpcln) && -e $newname) {
            $output = "The $ftype $file had been renamed to:\n $newname";
          };
        } else {
          &PromptSav('Rename',$file,$ftype,&FullPath($pwd,$file)) unless ($pcntr);
       };
      } elsif ($fmcom eq 'FCopy') {
        if ($csav) {
          &WebrshDie("This form had expired\!") unless ($pcntr == $counter - 1);
          if (&CopyFile($file,$newname,$overwrite,$clpcln)) {
            $output = "The $ftype $file had been successfuly copied to\n $newname";
          };
        } else {
          &PromptSav('FCopy',$file,$ftype,&FullPath($pwd,$file)) unless ($pcntr);
       };
      } elsif ($fmcom eq 'Cut') {
        $clip = join(' ','Cut',&FullPath($pwd,$file));
      } elsif ($fmcom eq 'Copy') {
        $clip = join(' ','Copy',&FullPath($pwd,$file));
#      } elsif ($fmcom eq 'GET')  {
#        &SendFile($file);
#        $done = 1;
      } elsif ($fmcom eq 'GetasTEXT') {
        &SendTextFile($file);
        $done = 1;
      } elsif ($fmcom eq 'GetasBIN') {
        &SendBinFile($file);
        $done = 1;
      };
    }; 
  } elsif ($fmcom eq 'Paste') {
    if ($clip) {
      local($clcom,$clfile) = split(' ',$clip,2);
      &WebrshDie("Can\'t find $clfile: $!") unless (-e $clfile);
      if (-d $clfile) {$ftype = 'directory';} else {$ftype = 'file';};
      unless ($newname) { 
        $newname = &FileName($clfile);
        $newname = &FullPath($pwd,$newname) if ($newname);
      };
      if ($newname && $clcom eq 'Cut') {
        if (&RenameFile($clfile,$newname,$overwrite,'1') && -e $newname) {
          $output = "The $ftype $clfile had been renamed to:\n $newname";
        };
      } elsif ($newname && $clcom eq 'Copy') {
        if (&CopyFile($clfile,$newname,$overwrite,1)) {
          $output = "The $ftype $clfile had been successfuly copied to\n $newname";
        };
      };
    };
  };
  $output = 'ok' unless ($output);
}

sub PromptNew { # Prompts to create a new file or directory.

  local($fexist,$nftype,$newname) = @_;
  print "Content-type: text/html\n\n";
  print '<HTML><HEAD><TITLE> WebRSH - New </TITLE></HEAD>',"\n",
  ' <BODY bgcolor="',"$BGColor\" $BodyParam",'><H2> WebRSH: New: ';
  print 'File Already Exists ' if ($fexist);
  print '</H2>',"\n";
#  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  unless ($fexist) {
    print '<H4> Please choose the type of the new object you wish to create, ',"\n",
    ' and enter a name for it. </H4><CENTER>',"\n";
  } else {
     print '<H4> Please enter another name for the new object you wish to create.',"\n",
     ' </H4><CENTER>',"\n";
  };
  print '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
  '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
  '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
  '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
  '<INPUT TYPE=hidden name="fmcom" value="New">',"\n",
  '<INPUT TYPE=hidden name="pcntr" value="',"$counter",'">',"\n",
  '<TABLE BGCOLOR="',"$TableColor\" $FTableParam",'>',"\n",
  '<TR><TD ALIGN="center">',"\n",
  '<TABLE ',"$TableParam",'><TR><TD ALIGN="center">',"\n";
  if ($nftype eq 'File') {
    print '<TABLE><TR><TD COLSPAN=44>',"\n",
    '<INPUT TYPE=radio name="nftype" value="Directory"> Directory </TD><TD>',"\n",
    '<INPUT TYPE=radio name="nftype" value="File" CHECKED>',"\n";
  } else {
    print ' <TABLE><TR><TD COLSPAN=44>',"\n",
    '<INPUT TYPE=radio name="nftype" value="Directory" CHECKED> Directory </TD>',"\n",
    '<TD><INPUT TYPE=radio name="nftype" value="File">',"\n";
  };
  print  'File </TD></TR></TABLE></TD></TR><TR><TD ALIGN="center">',"\n".
  '<INPUT TYPE=submit name="cnew" value="   Create:   ">',"\n",
  '<INPUT SIZE="',"$FNFieldSize",'" name="newname" value="',"$newname",'">',"\n",
  '</TD></TR><TR><TD ALIGN="center">',"\n",
  '<INPUT TYPE=submit VALUE="            Cancel            ">',"\n",
  '</TD></TR></TABLE></TD></TR></TABLE></FORM>',"\n",
  '</CENTER><HR></BODY></HTML>',"\n";
  $done = 1;
}

sub PromptDel { # Prompts to confirm deleting a file or a directory.

  local($file,$ftype) = @_;
  print "Content-type: text/html\n\n";
  print '<HTML><HEAD><TITLE> WebRSH - Delete </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor\" $BodyParam",'><H2> WebRSH: Delete: </H2>',"\n";
#  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  print '<H4> Are you sure you want to delete the ',"$ftype \'$file\'";
  print ' and all the files in it' if ($ftype eq 'directory');
  print ' ? </H4><CENTER>',"\n",
  '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
  '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
  '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
  '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
  '<INPUT TYPE=hidden name="fmcom" value="Delete">',"\n",
  '<INPUT TYPE=hidden name="pcntr" value="',"$counter",'">',"\n",
  '<INPUT TYPE=hidden name="file" value="',"$file",'">',"\n",
  '<TABLE BGCOLOR="',"$TableColor\" $FTableParam",'>',"\n",
  '<TR><TD ALIGN="center">',"\n",
  '<TABLE ',"$TableParam",'><TR><TD ALIGN="center">',"\n",
  '<INPUT TYPE=submit name="cdel" value="            Delete            ">',"\n",
  '</TD></TR><TR><TD ALIGN="center">',"\n",
  '<INPUT TYPE=submit VALUE="            Cancel            ">',"\n",
  '</TD></TR></TABLE></TD></TR></TABLE></FORM>',"\n",
  '</CENTER><HR></BODY></HTML>',"\n";
  $done = 1;
}

sub PromptSav { # Prompts to copy or rename a file or a directory.

  local($fmcom,$file,$ftype,$newname) = @_;
  local($dfmcom) = $fmcom;
  if ($fmcom eq 'FCopy') {$dfmcom = 'Copy';};
  print "Content-type: text/html\n\n";
  print '<HTML><HEAD><TITLE> WebRSH - ',"$dfmcom",' </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor\" $BodyParam",'><H2> WebRSH: ',"$dfmcom",': </H2>',"\n";
#  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  print '<H4> Please enter the new name for the ',"$ftype \'$file\'","\n",
  '</H4><CENTER>',"\n",
  '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
  '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
  '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
  '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
  '<INPUT TYPE=hidden name="fmcom" value="',"$fmcom",'">',"\n",
  '<INPUT TYPE=hidden name="pcntr" value="',"$counter",'">',"\n",
  '<INPUT TYPE=hidden name="file" value="',"$file",'">',"\n",
  '<TABLE BGCOLOR="',"$TableColor\" $FTableParam",'>',"\n",
  '<TR><TD ALIGN="center">',"\n",
  '<TABLE ',"$TableParam",'><TR><TD ALIGN="center">',"\n",
  '<INPUT TYPE="checkbox" name="overwrite" value="1"> Overwrite existing files',"\n",
  '</TD></TR><TR><TD ALIGN="center">',"\n",
  '<INPUT TYPE=submit name="csav" value="',"$dfmcom",' to:">',"\n",
  '<INPUT SIZE="',"$FNFieldSize",'" name="newname" value="',"$newname",'">',"\n",
  '</TD></TR><TR><TD ALIGN="center">',"\n",
  '<INPUT TYPE=submit VALUE="            Cancel            ">',"\n",
  '</TD></TR></TABLE></TD></TR></TABLE></FORM>',"\n",
  '</CENTER><HR></BODY></HTML>',"\n";
  $done = 1;
}

sub RenameFile { # Renames a file or a directory.

  local($file,$newname,$overwrite,$clpcln) = @_;
  local($success) = 0;
  &WebrshDie("Can\'t find $file \: $!") unless (-e $file);  
  if ($newname) {
    $! = 0;
    local($FileExists) = -e $newname;
    unless ($FileExists && -d $newname) {
      unless ($FileExists && !$overwrite) {
        if (rename($file,$newname)) {
          $success = 1;
          $clip = '' if ($clpcln);
        } else {&SaveProblem('Rename','Bad Filename',$file,$newname,$overwrite,$clpcln);};
      } else {&SaveProblem('Rename','File Already Exists',$file,$newname,$overwrite,$clpcln);};
    } else {&SaveProblem('Rename',"$newname is an Existing Directory",$file,$newname,$overwrite,$clpcln);};
  } else {&SaveProblem('Rename','No Filename',$file,$newname,$overwrite,$clpcln);};
  return $success;
}

sub CopyFile { # Copies a file or a directory.

  local($file,$newname,$overwrite,$clpcln) = @_;
  local($success) = 0;
  &WebrshDie("Can\'t find $file: $!") unless (-e $file);  
  if ($newname) {
    $! = 0;
    local($FileExists) = -e $newname;
    unless ($FileExists && -d $newname) {
      unless ($FileExists && !$overwrite) {
        if (-d $file) {
          $success = &DCopy($file,$newname);
        } else {
          if (!$FileExists || ($file ne $newname && unlink($newname))) {
            $success = &FCopy($file,$newname);
          } else {&SaveProblem('FCopy','Bad Filename',$file,$newname,$overwrite,$clpcln);};
        };
        $clip = '' if ($clpcln);
      } else {&SaveProblem('FCopy','File Already Exists',$file,$newname,$overwrite,$clpcln);};
    } else {&SaveProblem('FCopy',"$newname is an Existing Directory",$file,$newname,$overwrite,$clpcln);};
  } else {&SaveProblem('FCopy','No Filename',$file,$newname,$overwrite,$clpcln);};
  return $success;
}

sub SaveProblem { # Prompts for corrective action in case RenameFile or CopyFile run into problems.

  local($fmcom,$problem,$file,$newname,$overwrite,$clpcln) = @_;
  local($dfmcom) = $fmcom;
  $dfmcom = 'Copy' if ($fmcom eq 'FCopy');
  print "Content-type: text/html\n\n";
  print '<HTML><HEAD><TITLE> WebRSH - File Saving Problem </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor\" $BodyParam",'>',"\n",
  '<H2> WebRSH: ',"$dfmcom",' Problem: ',"$problem\: $!",' </H2>',"\n";
#  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  print '<H4> Please choose one of the following: </H4><CENTER>',"\n",
  '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
  '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
  '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
  '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
  '<INPUT TYPE=hidden name="file" value="',"$file",'">',"\n",
  '<INPUT TYPE=hidden name="newname" value="',"$newname",'">',"\n",
  '<INPUT TYPE=hidden name="fmcom" value="',"$fmcom",'">',"\n",
  '<INPUT TYPE=hidden name="pcntr" value="',"$counter",'">',"\n",
  '<INPUT TYPE=hidden name="clpcln" value="',"$clpcln",'">',"\n",
  '<INPUT TYPE=hidden name="overwrite" value="1">',"\n",
  '<TABLE BGCOLOR="',"$TableColor\" $FTableParam",'>',"\n",
  '<TR><TD ALIGN="center">',"\n",
  '<TABLE ',"$TableParam",'><TR><TD ALIGN="center">',"\n";
  if ($problem eq 'File Already Exists') {
    print '<INPUT TYPE=submit name="csav" VALUE="  Overwrite existing file  ">',"\n",
    '</TD></TR><TR><TD ALIGN="center">',"\n";
  }; 
  print '<INPUT TYPE=submit VALUE="            Cancel            ">',"\n",
  '</TD></TR></FORM>',"\n",
  '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
  '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
  '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
  '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
  '<INPUT TYPE=hidden name="file" value="',"$file",'">',"\n",
  '<INPUT TYPE=hidden name="fmcom" value="',"$fmcom",'">',"\n",
  '<INPUT TYPE=hidden name="pcntr" value="',"$counter",'">',"\n",
  '<INPUT TYPE=hidden name="clpcln" value="',"$clpcln",'">',"\n",
  '<INPUT TYPE=hidden name="overwrite" value="',"$overwrite",'">',"\n",
  '<TR><TD ALIGN="center">',"\n",
  '<INPUT TYPE=submit name="csav" VALUE="',"$dfmcom",' to:">',"\n",
  '<INPUT SIZE="',"$FNFieldSize",'" name="newname" value="',"$newname",'">',"\n",
  '</TD></TR></TABLE></TD></TR></TABLE></FORM></CENTER><HR></BODY></HTML>',"\n";
  $done = 1;
}

sub MakeStr { # Duplicates a string to form a longer string.

  local($str,$length) = @_;
  local($i,$outstr) = (0,'');
  foreach $i (1..$length) {
    $outstr = join('',$outstr,$str);
  };
  return $outstr;
}

sub TruncStr { # Truncates a string to fit a specified length if it is too long. Attaches '...'
               # to its end if a truncation occurs.

  local($str,$length) = @_;
  if (length($str) > $length) {
     $str = join('',substr($str,0,$length - 3),'...');
  };
  return $str;
}

sub PrintFM { # Prints File Manager or Text Editor output.

  if ($PrintEd) {
    &PrintEdit;
  } else {
    &PrintFMO;
  };
}

sub PrintFMO { # Prints File Manager output.

  print '<HTML><HEAD><TITLE> WebRSH - File Manager </TITLE>',"\n";
  local($JSstr) = '';
  if ($XPath) {
    print '<SCRIPT LANGUAGE="JavaScript">',"\n",
    '<!---',"\n",
    'function fnepi() {',"\n",
    '  var si = document.fmMain.file.selectedIndex',"\n",
    '  if (si <= 0) {',"\n",
    '    return ""',"\n",
    '  } else {',"\n",
    '    var fn = document.fmMain.file.options[si].value',"\n",
    '    var fnt = document.fmMain.file.options[si].text',"\n",
    '    if ((fnt.charAt(0) == ',"\"\\\\\"",') || (fn == "")) {',"\n",
    '      return ""',"\n",
    '    } else {',"\n",
    '      return "/" + escape(fn)',"\n",
    '    }',"\n",
    '  }',"\n",
    '}',"\n",
    '// -->',"\n",
    '</SCRIPT>',"\n";
    $JSstr = " onClick=\"fmMain.action = fmMain.action + fnepi()\"";
  };
  print '</HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor\" $BodyParam",'><B> WebRSH: File Manager: </B>',"\n";
#  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  unless ($output) {print '<H4> Your command did not generate any output </H4>',"\n";}
  else {
    &GetDirList(1); &GetFileList(1);
    if ($output ne 'ok') {print ' <HR><PRE>',&HtmlText($output),'</PRE>',"\n";};
    if ($fmUpload) {
      print '<HR><B> Upload to: ',"$pwd\n",'</B><CENTER>',"\n",
      '<FORM METHOD="POST" ENCTYPE="multipart/form-data" ACTION="',"$ScriptUrl",'">',"\n",
      '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
      '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
      '<INPUT TYPE=hidden name="com" value="rshupload fm">',"\n",
      '<TABLE BGCOLOR="',"$TableColor\" $FTableParam",'>',"\n",
      '<TR><TD ALIGN="center">',"\n",
      '<TABLE ',"$TableParam",'><TR><TD ALIGN="center"><TABLE><TR><TD>',"\n",
      '<INPUT TYPE="checkbox" name="ow" value="1"> Overwrite Existing File </TD>',"\n",
      '<TD NOWRAP COLSPAN=8></TD><TD>',"\n",
      '<INPUT TYPE="checkbox" name="tm" value="1"> Text Mode </TD></TR></TABLE></TD></TR>',"\n",
      '<TR><TD ALIGN="center">FILE TO UPLOAD: <INPUT TYPE=file NAME=upfile SIZE="40"></TD></TR>',"\n",
      '<TR><TD ALIGN="center"><INPUT VALUE="        Upload        "  TYPE=submit></TD></TR></TABLE>',"\n",
      '</TD></TR></TABLE></FORM></CENTER>',"\n";
    };
    if ($fmProps) {
      print '<HR><B> Properties of: ',"$input{'file'}\n</B><PRE>",
      &HtmlText($fmProps),"\n</PRE><P>\n";
      &PrintAttForm($input{'file'}) if ($Win32);
    };
    if ($clip) {
      local($clcom, $clfile) = split(' ',$clip,2);
      local($fmcom,$ftype,$newname);
      if (-d $clfile) {$ftype = 'directory';} else {$ftype = 'file';};
      $newname = &FileName($clfile);
      if ($newname) {$newname = &FullPath($pwd,$newname);};
      if ($newname && $clcom eq 'Cut') {$fmcom = 'Rename';}
        elsif ($newname && $clcom eq 'Copy') {$fmcom = 'FCopy';};
      print '<HR><CENTER>',"\n",
      '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
      '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
      '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
      '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
      '<INPUT TYPE=hidden name="fmcom" value="',"$fmcom",'">',"\n",
      '<INPUT TYPE=hidden name="pcntr" value="',"$counter",'">',"\n",
      '<INPUT TYPE=hidden name="file" value="',"$clfile",'">',"\n",
      '<INPUT TYPE=hidden name="clpcln" value="1">',"\n",
#      '<INPUT TYPE="checkbox" name="overwrite" value="1"> Overwrite existing files <BR><BR>',"\n",
      '<TABLE BGCOLOR="',"$TableColor\" $FTableParam",'>',"\n",
      '<TR><TD ALIGN="center">',"\n",
      '<TABLE ',"$TableParam",'><TR><TD>',"\n",
      '<B> Clipboard content is: ',"$clip",'</B></TD></TR><TR><TD>',"\n",
      '<INPUT TYPE=submit name="csav" value="Paste as:">',"\n",
      '<INPUT SIZE="',"$FNFieldSize",'" name="newname" value="',"$newname",'"></TD></TR>',"\n",
      '<TR><TD><INPUT TYPE=submit name="fmcancel" VALUE="            Cancel            ">',"\n",
      '</TD></TR></TABLE></TD></TR></TABLE></FORM></CENTER>',"\n";
    };
    print '<CENTER><HR>',"\n",
    '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'" NAME="fmMain">',"\n",
    '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
    '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
    '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
    '<TABLE BGCOLOR="',"$TableColor\" $FTableParam",'>',"\n",
    '<TR><TD ALIGN="center">',"\n",
    '<TABLE ',"$TableParam",'><TR><TD ALIGN="center"><B>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshfm&file=..&fmcom=Open%2FGet">',"\n",
    '<IMG SRC="',"$SendFilesUrl",'/highdir.gif" ALIGN=top HSPACE=0 BORDER=0 ALT="Up"></A>',"\n",
    'Directory: ',"$pwd",' </B></TD></TR><TR><TD ALIGN="center">',"\n",
    '<SELECT NAME="file" SIZE="',"$FMSize",'">',"\n",
    '<OPTION VALUE=".."> \.. ',"\n";
    foreach $i (0..$#dirarray) {
      print '<OPTION VALUE="',"$dirarray[$i]",'"> ',&TruncStr("\\$dirarray[$i]",$FMHSize),"\n";
    };
    print '<OPTION VALUE=""> ',"\n",&MakeStr('-',$FMHSize),"\n";
    foreach $i (0..$#filearray) {
      print '<OPTION VALUE="',"$filearray[$i]",'"> ',&TruncStr($filearray[$i],$FMHSize),"\n";
    };
    print '</SELECT></TD></TR><TR><TD ALIGN="center">',"\n",
    '<INPUT TYPE=submit name="fmcom" value="Open/Get"',"$JSstr>\n",
    '<INPUT TYPE=submit name="fmcom" value="  Cut  ">',"\n",
    '<INPUT TYPE=submit name="fmcom" value=" Copy  ">',"\n",
    '<INPUT TYPE=submit name="fmcom" value=" Paste ">',"\n",
    '<INPUT TYPE=submit name="fmcom" value="Delete ">',"\n",
    '<INPUT TYPE=submit name="fmcom" value="Rename ">',"\n",
    '<INPUT TYPE=submit name="fmcom" value="  New  "></TD></TR><TR><TD ALIGN="center">',"\n",
    '<INPUT TYPE=submit name="fmcom" value="   Edit    ">',"\n",
#    '<INPUT TYPE=submit name="fmcom" value="    GET    "',"$JSstr>\n",
    '<INPUT TYPE=submit name="fmcom" value="Get as BIN "',"$JSstr>\n",
    '<INPUT TYPE=submit name="fmcom" value="Get as TEXT"',"$JSstr>\n",
    '<INPUT TYPE=submit name="fmcom" value="  Upload   ">',"\n",
    '<INPUT TYPE=submit name="fmcom" value="Properties ">',"\n",
    '</TD></TR></TABLE></TD></TR></TABLE></FORM></CENTER>',"\n";
  }
}

1; # return true
