# frames.pl - A plugin that implements WebRSH Frames Interface
# This file is part of WebRSH 1.1b (beta)
# Copyright (C) 1997,1998  Yoram Last (ylast@mindless.com)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

$MainMenuWidth = '118';
# Width of the Main Menu frame.

$ComLineWidth = '46';
# Width of the command line frame.

#################################################################################

$WRid = $rshId;
$WRid =~ s/[fcm]//g;
$WRid = "cm$WRid";

$Brsr = $ENV{'HTTP_USER_AGENT'};
if (($Brsr =~ m/^Mozilla\/2\.0/) && !($Brsr =~ m/compatible/) && !($Brsr =~ m/MSIE/)) {
  ($ScrLang,$WRMenu) = ('JavaScript','wrmenu.moz2.html');
} else {
  ($ScrLang,$WRMenu) = ('JavaScript1.1','wrmenu.html');
}

$FramesetStr = join('',
'<FRAMESET COLS="',"$MainMenuWidth",',*" FRAMEBORDER=1 MARGINWIDTH=0 MARGINHEIGHT=0 onLoad="InitWebRSH()">
<FRAME NAME="WRMainMenu" SRC="',"$SendFilesUrl/$WRMenu",
'" FRAMEBORDER=0 MARGINWIDTH=0 MARGINHEIGHT=2>
<FRAMESET ROWS="*,',"$ComLineWidth",'" FRAMEBORDER=1 MARGINWIDTH=0 MARGINHEIGHT=0>
<FRAME NAME="WRMainFrame" SRC="',"$ScriptUrl\?id\=$WRid\&pwd\=$rshlPWD",'">
<FRAME NAME="WRComLine" SRC="',"$SendFilesUrl/wrcomline\.html",
'" SCROLLING="no" FRAMEBORDER=1 MARGINWIDTH=0 MARGINHEIGHT=0>
</FRAMESET>
</FRAMESET>
<NOFRAMES>
');

print "Content-type: text/html\n\n";
print '<HTML><HEAD><TITLE> WebRSH Frames Interface </TITLE>',"\n",
'<SCRIPT LANGUAGE="',"$ScrLang",'">',"\n",'<!---',"\n",
'
var OStype     = ',"\'$OStype\'",'
var WRmethod   = ',"\'$ReqMeth\'",'
var WRaction   = "',&EscapedText($ScriptUrl),'"
var WRid       = ',"\'f$WRid\'",'
var WRpwd      = "',&EscapedText($rshPWD),'"

function InitWebRSH() {
  WRid=\'f\'+self.WRMainFrame.document.WebRSHMain.id.value
  window.onfocus=SetStatus
  window.onresize=SetStatus
  self.WRMainMenu.window.onfocus=SetStatus
  self.WRMainMenu.window.onresize=SetStatus
  self.WRComLine.window.onfocus=SetStatus
  self.WRComLine.window.onresize=SetStatus
  var WorkDirDisplayStr = \'Working Directory: \' + WRpwd
  self.WRMainMenu.window.defaultStatus=WorkDirDisplayStr
  self.WRComLine.window.defaultStatus=WorkDirDisplayStr
  self.WRMainFrame.window.defaultStatus=WorkDirDisplayStr
  window.defaultStatus=WorkDirDisplayStr
  window.status=WorkDirDisplayStr
  return true
}

function UpdateWebRSH() {
  WRmethod=self.WRMainFrame.document.WebRSHMain.method
  WRaction=self.WRMainFrame.document.WebRSHMain.action
  WRid=self.WRMainFrame.document.WebRSHMain.id.value
  WRpwd=self.WRMainFrame.document.WebRSHMain.pwd.value
  var WorkDirDisplayStr = \'Working Directory: \' + WRpwd
  self.WRMainMenu.window.defaultStatus=WorkDirDisplayStr
  self.WRComLine.window.defaultStatus=WorkDirDisplayStr
  self.WRMainFrame.window.defaultStatus=WorkDirDisplayStr
  window.defaultStatus=WorkDirDisplayStr
  window.status=WorkDirDisplayStr
  if (self.WRComLine.document.WRCL) {
    self.WRComLine.document.WRCL.com.value=\'\'
  }
  return true
}

function SetStatus() {
  var WorkDirDisplayStr = \'Working Directory: \' + WRpwd
  self.WRMainMenu.window.defaultStatus=WorkDirDisplayStr
  self.WRComLine.window.defaultStatus=WorkDirDisplayStr
//  self.WRMainFrame.window.defaultStatus=WorkDirDisplayStr
  window.defaultStatus=WorkDirDisplayStr
  window.status=WorkDirDisplayStr
  return true
}

function DoFrames() {
  document.write("',&EscapedText($FramesetStr),'")
}

function MakePlugLinkPwd(pwd) {
  var pwdStr = \'\'
  var tmpStr = \'\'
  var j = 0
  for (i = 0; i <= pwd.length; i++) {
    if (pwd.charAt(i) == \'/\' || pwd.charAt(i) == "\\\\" || pwd.charAt(i) == \'\') {
      tmpStr = pwd.substring(j,i)
      tmpStr = escape(tmpStr)
      pwdStr = pwdStr + \'/\' + tmpStr
      j = i + 1
    }
  }
  if (pwdStr.charAt(0) != \'/\') {
    pwdStr = \'/\' + pwdStr
  }
  return pwdStr
}

function MakePlainId(id) {
  var idStr = \'\'
  var tmpStr = \'\'
  var j = 0
  for (i = 0; i <= id.length; i++) {
    if (id.charAt(i) == \'f\' || id.charAt(i) == \'c\' ||
          id.charAt(i) == \'m\' || id.charAt(i) == \'\') {
      tmpStr = id.substring(j,i)
      idStr = idStr + tmpStr
      j = i + 1
    }
  }
  return idStr
}

function MakeComLink(com) {
  var ComUrl = WRaction + \'?id=\' + WRid + \'&pwd=\' + escape(WRpwd) +
        \'&com=\' + escape(com)
  return ComUrl
}

function MakePluginLink(plugin) {
  var PIUrl = WRaction + \'/rshplugin/\' + WRid + MakePlugLinkPwd(WRpwd) +
        \'%3A%3A/\' + plugin
  return PIUrl
}

function MakePlainLink() {
  var PlainUrl = WRaction + \'?id=\' + MakePlainId(WRid) + \'&pwd=\' + escape(WRpwd)
  return PlainUrl
}

// -->
</SCRIPT>
</HEAD>

<SCRIPT LANGUAGE="',"$ScrLang",'">
<!---

DoFrames()

// -->
</SCRIPT>

<BODY bgcolor="',"$BGColor\" $BodyParam",'>
<CENTER><H1> Welcome to WebRSH </H1></CENTER>
<B> If you see this page, then your web browser does not support JavaScript at
the required level, or it does not support frames, or both. You should
still be able to use WebRSH successfully, but without the Frames Interface.
</B>',"\n";

$AppendToPI = 1;

sub EscapedText {

  local($str) = @_;
  $str =~ s/(\r|\n)//g;
  $str =~ s/(\W)/\\$1/g;
  return $str
}

1; # return true
