#!/usr/bin/perl
#
# WebRSH 1.1b (beta) A Remote-Computing CGI Program.
# Copyright (C) 1997,1998  Yoram Last (ylast@mindless.com)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# Please see the accompanying documentation for usage instructions.
#
# WARNING: This program has an above-average potential for causing damage!
# In particular, it may allow unauthorized remote access to your computer and to
# network resources available to your computer. It may also cause your computer
# to "crash" while you are away from it and thus unable to restart it. It is
# recommended that you avoid using this program unless "you know what you are doing."
# You should avoid placing this program in any publicly accessible CGI-enabled
# directory on your system.

$VerInf = join('','<SMALL>WebRSH 1.1b (beta) by ',"\n",
      '<B><I><A HREF="mailto:Yoram Last &lt;ylast@mindless.com&gt;">ylast</A></I></B></SMALL>');
# WebRSH version information and author mailto link.

$! = 0;
# Set error to none.

#-!-!-!> DO NOT MODIFY THIS LINE, AND DO NOT ADD A '#-!-!-!>' ANYWHERE ELSE IN THIS SCRIPT!
#################################################################################################
# The following variables can be configured through WebRSH's 'Options' menu item. It is         #
# recommended that you DO NOT make any manual modifications to this part of the script.         #
#################################################################################################

$ProgDir = '~/WebRSH';
# Path to WebRSH's main directory.

$SendFilesDir = "$ProgDir/sfdir";
# The path to a directory that can be accessed through the server, and is used to place icons.

$SendFilesUrl = '/sfdir';
# URL of $SendFilesDir (The path by which it is recognized by the server).

$HomeDir = "$ProgDir/home";
# The default working directory for WebRSH.

$CfgDir = "$ProgDir/cfg";
# A directory in which configuration files are stored.

$TempDir = "$ProgDir/temp";
# A directory to which temporary files are written.

$PlugInDir = "$ProgDir/lib";
# A directory where plugins should reside.

$LocSecurity = 1;
# Setting it to 1 enables location based access restriction. Setting it to 0 disables it.

@AllowAddr = ('127\.0\.0\.1');
# ('a','coma','separated','list','of','IP','patterns','in','qoutes')
# from which access to WebRSH is allowed.

@DenyAddr = ();
# Similarly, a list of patterns from which to deny access.

$CheckForAuth = 0;
# If set to 1, the script will varify that some access authentication took place by checking for
# the existence of the environment variable 'AUTH_TYPE'. Setting it to 0 disables this check.

$CheckForUser = 0;
# If set to 1, only users that appear in the @AllowUsers array will be allowed access to WebRSH.
# If set to 0, all users (that have been allowed access by the server) will be allowed.

@AllowUsers = ();
# ('a','coma','separated','list','of','user names','in','qoutes') for which access to WebRSH
# will be allowed.

$MakeBack = 1;
# If set to 1, a backup copy of the main script will be saved whenever options are changed.
# This backup copy will have the same name as the main script except for a '-' added just
# before the extension. If set to 0, no backup will be done.

$BGColor = '#fffbf0';
# The background color used for WebRSH pages.

$BodyParam = '';
# Additional parameters (other than background color) for the BODY tag of WebRSH pages.

$TableColor = 'silver';
# The background color used for the outer (framing) tables of WebRSH forms.

$FTableParam = 'BORDER=2 CELLSPACING=0 CELLPADDING=1';
# Additional parameters (other than background color) for the outer (framing) tables
# of WebRSH forms.

$TableParam = 'BORDER=1 CELLSPACING=0 CELLPADDING=4';
# Parameters for the inner (primary) tables of WebRSH forms.

$HostName = 'the remote host';
# The name of the computer running WebRSH. This is only used in generating text for some of
# WebRSH's documents.

$GetOptions = 'T';
# Determines the kind of "downloadable links" that will be generated (in addition to the usual
# 'GET' links) as part of the  appropriate directory listings. 'B' will generate 'GET as BIN'
# links. 'T' will generate 'GET as TEXT' links. 'BT' will generate both.

$BinText = 1;
# If set to 1, files sent with the 'GET as TEXT' option will be sent in their exact binary
# format (which is the same way they are sent with the 'GET' or 'GET as BIN' options).
# If set to 0, such files will be converted to a non-native text format (namely, LF characters
# will be converted to CR-LF pairs or vice versa). That is, if WebRSH is running on UNIX, the
# files will be converted to WinDOS format, and if WebRSH is running on Win32, they will be
# converted to UNIX format.

$DefMimeType = 'application/octet-stream';
# Default MIME type to be reported for downloaded files. Only relevant for files with extensions
# that do not appear in Mimetable.txt.

$XPath = 1;
# If set to 1, file names will be added as extra path information whenever files are downloaded
# through one of the 'GET' options. This enables the browser to know the correct filename for
# downloaded files. If set to 0, such extra path information will not be added.

$GCLH = 1;
# If set to 1, the script will supply a 'Content-length' header when a file is dowloaded through
# one of the 'GET' options or when responding to an 'rshtextmode' command. If set to 0, such a
# header will not be provided.

$ReqMeth = 'GET';
# The request method used by most of WebRSH's forms.

$AppendToPI = 1;
# Determines whether or not WebRSH will append its main form to the output of plugins. The
# plugin itself can always modify $AppendToPI to override the default behavior set here.

$PsLib = 'pslib-linux.pl';
# The name of the library file to supply process related subroutines.

$ComFieldSize = '64';
# Size of the command input field in WebRSH's main form.

$FNFieldSize = '56';
# Size of input fields containing filenames in many WebRSH forms.

$FMSize = '14';
# Vertical size of the File Manager select field.

$FMHSize = '64';
# Horizontal size of the File Manager select field.

$EdCols = '72';
# Horizontal width (in columns) of the Text Editor window.

$EdRows = '22';
# Vertical width (in rows) of the Text Editor window.

$EdWrap = '';
# Sets the line wrapping option for the Text Editor window. This is only relevant when used with
# suitable browsers (mainly, with Netscape Navigator). Valid options are 'virtual', 'physical',
# and '' (none).

$EdEmptyLnHldr = ' ';
# Added to empty lines when files are opened with the Text Editor. Removed when the Text Editor
# saves a file--if it is the only content of a line. This is used to preserve empty lines in
# text files, since some browsers (notably Lynx) tend to strip them.

$EdOPFL = 1;
# If set to 1, only the first line of files opened with the Text Editor (if it is empty)
# will be protected with the $EdEmptyLnHldr mechanism. If set to 0 and $EdEmptyLnHldr is not
# null, all empty lines will be protected.

$EdHtmlText = 1;
# If set to 1, files opened with the Text Editor will be converted to HTML-formatted text using
# the HtmlText subroutine. If set to 0, such conversion will not take place. An appropriate
# setting here is very important (in particular, to enable editing of HTML files), and depends
# on the browser: Netscape Navigator, Microsoft Internet Explorer, and Lynx require the setting
# to be 1. Other browsers (e.g., NCSA Mosaic 3.0) may require it to be 0.

$EdTAMod = '/';
# This will be added to follow the first '<' in any </TEXTAREA> tag when files are opened with
# the Text Editor. It will be removed from such tags when the Text Editor saves a file. This
# mechanism enables editing of HTML files containing </TEXTAREA> tags with browsers that require
# $EdHtmlText to be set to 0. It is active only if $EdHtmlText is set to 0.

$UseWin32Console = 0;
# This only comes into play on Win32 platforms. If set to 1, WebRSH assumes it can communicate
# with programs executed by it using STDIN/STDOUT, which requires WebRSH itself to be executed
# with a full console. If set to 0, this is not assumed, and WebRSH will obtain output of other
# programs by redirecting it to a temporary file and reading it from there. It should be set to
# 1 if and only if WebRSH is being executed with a full console (this is determined by the
# executing web server).

$LoginShell = 1;
# This only comes into play on UNIX platforms. If set to 1, WebRSH will do its best to emulate
# the user's login environment. It will try to get the user's login shell and home directory
# from the system, and will try to get the proper default umask (by extracting it from a shell)
# whenever files are created. Furthermore, if the user's login shell supports being run as a
# non-interactive login shell (namely, if it is either bash, ksh, or zsh), commands will be
# executed through a login shell. If set to 0, such initialization would not take place, and
# it may be needed to manually set the proper umask and some environment variables below.

$ColFilter = 1;
# This only comes into play on UNIX platforms. If set to 1, output from shell commands will be
# filtered through 'col' to remove control characters (this is important to make things like
# 'man *' work properly). If set to 0, such filtering would not take place and WebRSH will
# present the raw STDOUT output of commands. It is recommended to set this to 1 as long as
# you have 'col'. This setting does not effect the 'rshtextmode' command which always provides
# raw STDOUT output.

#-!-!-!> DO NOT MODIFY THIS LINE, AND DO NOT ADD A '#-!-!-!>' ANYWHERE ELSE IN THIS SCRIPT!
#################################################################################################
# The following variables can be optionally configured. Do not change them without reason.      #
#################################################################################################

$BufSize = 32768;
# The default size (in bytes) for buffers.

$OStype = '';
# The operating system in use (either 'w95', 'wNT' or 'U'). If left null, the script should
# find it out by itself.

$ScriptUrl = $ENV{'SCRIPT_NAME'};
# URL of this script (The path by which it is recognized by the server).

umask 066;
# The default umask for the WebRSH process. This only comes into play on UNIX platforms and
# probably only when $LoginShell is set to 0. Comment it out to preserve a previous umask.

#################################################################################################
# The following space should be used to modify the environment as needed.                       #
#################################################################################################

# $ENV{'PATH'} = "$ENV{'PATH'}:/usr/X11R6/bin"; # Enable and modify as needed.

# $ENV{'PATH'} = 'C:\WINDOWS;C:\WINDOWS\COMMAND;'; # Enable and modify as needed.

# $ENV{'COMSPEC'} = 'C:\WINDOWS\COMMAND.COM'; # Enable and modify as needed.

# $ENV{'DIRCMD'} = ''; # Enable and modify as needed.

# $ENV{'TEMP'} = "$TempDir"; # Enable and modify as needed.

# $ENV{'TMP'} = "$TempDir"; # Enable and modify as needed.

# $ENV{'SHELL'} = '/bin/bash'; # Enable and modify as needed.

# $ENV{'HOME'} = $HomeDir; # Enable and modify as needed.

# $ENV{'USER'} = 'nobody'; # Enable and modify as needed.

#################################################################################################
# The WebRSH program starts from here:                                                          #
#################################################################################################

unless ((!$LocSecurity || &AllowAddr($ENV{'REMOTE_ADDR'})) &&
        (!$CheckForAuth || $ENV{'AUTH_TYPE'}) && 
        (!$CheckForUser || &ConfirmUser)) {
  &WebrshDie('You are not allowed to access this program!');
};

&GetOStype || &WebrshDie("Can\'t tell OS type");

if ($ENV{'PATH_INFO'} =~ m/^(|$ScriptUrl)\/rshplugin\/(\w*)(\/.*|)\:\:\/(.+)$/)
{ # If a plugin is called, call it.

  ($PrePathInfo,$rshId,$rshPWD,$rshPlugIn) = ($1,$2,$3,$4);
  $rshplPWD = &UrlEncode($rshPWD);
  $rshplPWD =~ s/%2F/\//g;
  if ($Win32) {
    $rshPWD =~ s/^\///;
    $rshPWD =~ s/\//\\/g;
  };
  $rshlPWD = &UrlEncode($rshPWD);
  if ($rshPlugIn =~ m/^([^\/]+)(\/.*)$/) {
    $rshPlugIn = $1;
    $rshPathInfo = $2;
  } else {
    $rshPathInfo = '';
  };
  if (!$PrePathInfo) {
    $ENV{'PATH_INFO'} = $rshPathInfo;
    if ($ENV{'PATH_INFO'}) {
      if ($ENV{'PATH_TRANSLATED'} =~ m/^(.*)([\\\/])rshplugin([\\\/])$rshId/) {
        local($ServRoot,$Slash) = ($1,$3);
        $rshPathInfo =~ s/\//$Slash/g if ($Slash ne '/');
        $ENV{'PATH_TRANSLATED'} = "$ServRoot$rshPathInfo";
      } else {
        $ENV{'PATH_TRANSLATED'} = ''; delete $ENV{'PATH_TRANSLATED'};
      };
    } else {
      delete $ENV{'PATH_INFO'};
      $ENV{'PATH_TRANSLATED'} = ''; delete $ENV{'PATH_TRANSLATED'};
    };
  };
  $ENV{'SCRIPT_NAME'} = "$ScriptUrl/rshplugin/$rshId$rshplPWD\%3A\%3A/$rshPlugIn";
  if ($rshPlugIn =~ s/^LibPI//) {
    $rshPlugIn = "$ProgDir/lib/$rshPlugIn";
  } else {
    &ChangeDir("$PlugInDir") ||
      &WebrshDie("Can\'t change working directory to $PlugInDir \: $!");
    $0 = "$PlugInDir/$rshPlugIn";
  };
  (-f $rshPlugIn && -r _) ||
    &WebrshDie("Can\'t access the plugin $rshPlugIn \: $!");
  require "$rshPlugIn";
  select STDOUT;
  if ($AppendToPI) {
#    print "\n",'<HTML><BODY bgcolor="',"$BGColor",'">',"\n";
    print "\n";
    ($id,$pwd,$lpwd,$plpwd) = ($rshId,$rshPWD,$rshlPWD,$rshplPWD);
    &PrintWebRSHMainForm;
    print '</BODY></HTML>',"\n";
  };

} else { # Otherwise, run WebRSH.

  &UnixInit if ($OStype eq 'U');

  require "$ProgDir/lib/cgi-lib.pl" ||
    &WebrshDie("Can\'t require cgi-lib\.pl \: $!");

  # Reset some cgi-lib parameters
  $cgi_lib'maxdata =  1073741824;      # maximum bytes to accept via POST
  $cgi_lib'writefiles = $TempDir;      # temporary directory to which to write files
  $cgi_lib'bufsize  =  $BufSize;       # default buffer size when reading multipart

  unless ($ENV{'CONTENT_TYPE'} =~ m#^multipart/form-data#) {
    &ReadParse(*input);
  } else {
    &GetUmask if ($OStype eq 'U');
    &ReadParse(*input,*CFileName,*CContType,*TFileName);
    &WebrshDie unless ($input{'com'} =~ m/^rshupload/ && $TFileName{'upfile'});
  };

  $pwd = $input{'pwd'};
  $com = $input{'com'};
  &GetInidat;
  if ($pwd) {
    &ChangeDir($pwd) || &WebrshDie("Can\'t change working directory to $pwd \: $!");
  } else {
    &ChangeDir($HomeDir) || &WebrshDie("Can\'t change working directory to $HomeDir \: $!");
  };
  $id = $input{'id'};
  $id =~ y/0-9//d;
  $id = "$id$counter";

  if ($com) { # We sacrifice our own STDERR and pipe it to a handle we can read. Then we
              # execute our command, read STDERR, and append whatever we find there in
              # front of our output.

    pipe(SHELLERR,ERRPIPE); select(ERRPIPE); $| = 1;
    open(STDERR,">&ERRPIPE"); close(ERRPIPE);
    select(STDERR); $| = 1; select(STDOUT); # $| = 1;
    &DoCom;
    close(STDERR); local($err,$buf) = ('','');
    while (read(SHELLERR,$buf,$BufSize)) {
      $err .= $buf;
    };
    if ($err && $output eq 'ok') {
      $output = $err;
    } else {
      $output = join('',$err,$output);
    };
  };
  &GetPwd;
  &UpdInidat;
  &SendDone;
};

#################################################################################################
# Main subroutines:

sub UnixInit { # Does some initialization for UNIX platforms.

#  $< = $>;
  if ($LoginShell) {
    local(@user) = getpwuid("$>") unless ($ENV{'HOME'} && $ENV{'SHELL'} && $ENV{'USER'});
    $ENV{'HOME'} = $user[7] unless ($ENV{'HOME'});
    $ENV{'SHELL'} = $user[8] unless ($ENV{'SHELL'});
    $ENV{'USER'} = $user[0] unless ($ENV{'USER'});
  };
  if ($ENV{'HOME'} && !$HomeDir) {
    $HomeDir = $ENV{'HOME'};
#  } elsif ($HomeDir && !$ENV{'HOME'}) {
#    $ENV{'HOME'} = $HomeDir;
  };
}

sub GetInidat { # Gets the current $counter and file-manager information.

  open(INIDAT, "<$CfgDir/rshinidat.txt");
  $counter = <INIDAT>; chop($counter);
  $counter = $counter+1;
  $clip = <INIDAT>;
  close(INIDAT);
}

sub DoCom { # Executes the command $com.

  $com =~ s/[\r\n]//;
  ($mcom, $pcom) = split(/\s+/,$com,2);
  if ($mcom eq 'cd') {
    if ($pcom) {
      &ChangeDir($pcom) ||
        &WebrshDie("Can\'t change working directory to $pcom \: $!");
      $output = 'Directory had been changed';
    } else {
      if ($OStype eq 'U' && $ENV{'HOME'}) {
        &ChangeDir($ENV{'HOME'}) ||
          &WebrshDie("Can\'t change working directory to $ENV{'HOME'} \: $!");
        $output = 'Directory had been changed';
      } else {
        $output = `cd`;
      };
    };
  } elsif ($mcom eq 'rshhome') {
    &ChangeDir($HomeDir) ||
      &WebrshDie("Can\'t change working directory to $HomeDir \: $!");
    $output = 'Directory had been changed';
  } elsif ($mcom eq 'rshps') {
    require "$ProgDir/lib/$PsLib" ||
      &WebrshDie("Can\'t require $PsLib \: $!");
    $output = &RshPs;
  } elsif ($mcom eq 'rshkill') {
    require "$ProgDir/lib/$PsLib" ||
      &WebrshDie("Can\'t require $PsLib \: $!");
    $output = &RshKill($pcom);
  } elsif ($mcom eq 'rshlaunchlist' || $mcom eq 'rshexeclist' || $mcom eq 'rshgetlist') {
    require "$ProgDir/lib/listlib.pl" ||
      &WebrshDie("Can\'t require listlib\.pl \: $!");
    if ($pcom) {
      &ChangeDir($pcom) ||
        &WebrshDie("Can\'t change working directory to $pcom \: $!");
    };
    $output = 'ok';
  } elsif ($mcom eq 'rshkilllist') {
    require "$ProgDir/lib/$PsLib" ||
      &WebrshDie("Can\'t require $PsLib \: $!");
    &GetKillList;
    $output = 'ok';
  } elsif ($mcom eq 'rshgethtm') {
    $output = &GetHTM($pcom);
  } elsif ($mcom eq 'rshget') {
    &SendFile($pcom);
    $done = 1;
  } elsif ($mcom eq 'rshgettxt') {
    &SendTextFile($pcom);
    $done = 1;
  } elsif ($mcom eq 'rshgetbin') {
    &SendBinFile($pcom);
    $done = 1;
  } elsif ($mcom eq 'rshtextmode') {
    &TextMode($pcom);
    $done = 1;
  } elsif ($mcom eq 'rshuploadform') {
    require "$ProgDir/lib/upldlib.pl" ||
      &WebrshDie("Can\'t require upldlib\.pl \: $!");
    if ($pcom) {
      &ChangeDir($pcom) ||
        &WebrshDie("Can\'t change working directory to $pcom \: $!");
    };
    $output = 'ok';
  } elsif ($mcom eq 'rshfm') {
    require "$ProgDir/lib/fmlib.pl" ||
      &WebrshDie("Can\'t require fmlib\.pl \: $!");
    if ($pcom) {
      &ChangeDir($pcom) ||
        &WebrshDie("Can\'t change working directory to $pcom \: $!");
    };
    &DoFMCom;
  } elsif ($mcom eq 'rshupload') {
    require "$ProgDir/lib/upldlib.pl" ||
      &WebrshDie("Can\'t require upldlib\.pl \: $!"); 
    &DoUpload;
  } elsif ($mcom eq 'rshstart') {
    &RshStart($pcom);
  } elsif ($mcom eq 'rshperl') {
    $output = eval ($pcom);
  } elsif ($mcom eq 'rshoptions') {
    require "$ProgDir/lib/oplib.pl" ||
      &WebrshDie("Can\'t require oplib\.pl \: $!");
    &DoOpCom($input{'opt'},$input{'opcom'});
  } elsif ($mcom eq 'rshedit') {
    require "$ProgDir/lib/edlib.pl" ||
      &WebrshDie("Can\'t require edlib\.pl \: $!");
    &DoEditCom($pcom,'');
  } else {
    if ($Win32) {
       $output = &ExWin32Com($com);
    } else {
      $output = &ExUShellCom($com,$LoginShell,$ColFilter,1);
      $output =~ s/\n$//;
    };
  };
}

sub AllowAddr { # Determines whether an IP address is allowed access to WebRSH, based on
                # the @AllowAddr and @DenyAddr arrays.

  local($addr) = @_;
  local($allow,$i) = (0,0);
  if ($addr) {
    while (!$allow && $i <= $#AllowAddr) {
      $allow = 1 if ($addr =~ m/$AllowAddr[$i]/);
      $i++;
    };
    if ($allow) {
      $i = 0;
      while ($allow && $i <= $#DenyAddr) {
        $allow = 0 if ($addr =~ m/$DenyAddr[$i]/);
        $i++;
      };
    };
  };
  return $allow;
}

sub ConfirmUser { # Confirms that the accessing user is included in the @AllowUsers array.

  local($confirm,$i,$user) = (0,0,'');
  unless ($ENV{'SERVER_SOFTWARE'} =~ m/^WebSite/) {
    $user = $ENV{'REMOTE_USER'};
  } else {
    $user = $ENV{'AUTH_USER'};
  };
  while (!$confirm && $i <= $#AllowUsers) {
    $confirm = ($user eq $AllowUsers[$i]);
    $i++;
  };
  return $confirm;
}

sub WebrshDie { # Sends an error message and terminates execution of WebRSH.

  local(@msg) = @_;
  local($i);
  unless (@msg) {@msg = "WebRSH encountered a fatal error\n"};
  print "Content-type: text/html\n\n";
  print '<HTML><HEAD><TITLE> Execution Aborted </TITLE></HEAD><BODY><H2>',"\n",
  "$msg[0]",'</H2>',"\n";
  foreach $i (1 .. $#msg) {print '<P>',"$msg[$i]",'</P>',"\n";};
  print '<HR></BODY></HTML>',"\n";
  die @msg;
}

sub GetOStype { # Finds the operating system in use.

  if ($^O =~ m/Win32/ || (!$^O && $OStype ne 'U')) {
    $Win32 = 1;
    unless ($OStype) {
      local(@osinfo) = Win32::GetOSVersion;
      if ($osinfo[4] eq '2') {
        $OStype = 'wNT';
      } elsif ($osinfo[4] eq '1') {
        $OStype = 'w95';
      };
    };
  } else {
    $Win32 = 0;
    $OStype = 'U' unless ($OStype);
  };
  return $OStype;
}

sub GetPwd { # Updates $pwd, $lpwd, and $plpwd to hold the current working directory.

  if ($Win32) {
    $pwd = Win32::GetCwd;
    $lpwd = &UrlEncode($pwd);
    $plpwd = $lpwd;
    $plpwd =~ s/%5C/\//g;
    $plpwd = "/$plpwd";
  } else {
    require "$ProgDir/lib/getcwd.pl";
#    require "getcwd.pl";
    $pwd = &getcwd;
    $pwd = '/' unless ($pwd);
    $lpwd = &UrlEncode($pwd);
    $plpwd = $lpwd;
    $plpwd =~ s/%2F/\//g;
  };
}

sub UpdInidat { # Updates rshinidat.txt.

  open (INIDAT, ">$CfgDir/rshinidat.txt");
  print INIDAT "$counter\n$clip";
  close (INIDAT);
}

sub SendDone { # Prints WebRSH's html output

  unless ($done) {
    print "Content-type: text/html\n\n";
    $BodyParam = join('',$BodyParam,' onLoad="parent.UpdateWebRSH()"') if ($id =~ m/f/);
    if ($com) {
      if ($mcom eq 'rshlaunchlist') {&PrintLaunch;}
      elsif ($mcom eq 'rshkilllist') {&PrintKill;}
      elsif ($mcom eq 'rshexeclist') {&PrintExec;}
      elsif ($mcom eq 'rshgetlist') {&PrintGet;}
      elsif ($mcom eq 'rshuploadform') {&PrintUpload;}
      elsif ($mcom eq 'rshgethtm') {&PrintHTM;}
      elsif ($mcom eq 'rshfm' || $com eq 'rshupload fm') {&PrintFM;}
      elsif ($mcom eq 'rshoptions') {&PrintOptions;}
      elsif ($mcom eq 'rshedit') {&PrintEdit;}
      else {&PrintCom;};
    } else {&PrintNull;};
    &PrintWebRSHMainForm;
    print '</BODY></HTML>',"\n";
  }
}

#################################################################################################
# Secondary subroutines ("utilities"):

sub ExWin32Com { # Executes a Win32 shell command and returns its output.

  local($com) = @_;
  local($output) = '';
  if ($UseWin32Console) {
    $output = `$com`;
  } else {
    local($buf,$trstr) = ('','');
    local($tcom) = $com;
    local($tfile) = join('',$TempDir,"/webrsh-$counter",time,"\.temp");
#    $tfile =~ s/\//\\/g;
    $tcom =~ s/(^|[^\\])\".*[^\\]\"/$1/g;
    if ($OStype eq 'w95') {
      $trstr = " \>$tfile" unless ($tcom =~ m/\>.+/);
      $com =~ s/\"/\\\"/g;
      system("$ENV{'COMSPEC'} /c $com$trstr");
    } else {
      $trstr = " \>$tfile 2\>\&1" unless ($tcom =~ m/\>.+/);
#      system("$com$trstr");
      `$com$trstr`;
    };
    if ($trstr) {
      open(FILE,"<$tfile");
      while (read(FILE,$buf,$BufSize)) {
          $output .= $buf;
      };
      close(FILE);
      unlink($tfile);
    };
  };
  return $output;
}

sub ExUShellCom { # Executes a UNIX shell command and optionally returns its output.

  local($Com,$LoginShell,$ColFilter,$Wait) = @_;
  local($shell) = $ENV{'SHELL'};
  $shell = '/bin/sh' unless ($shell);
  local($logsw,$colflt,$output) = ('','','');
  if ($LoginShell) {
    if ($shell =~ m/bash$/) {
      $logsw = ' -login';
    } elsif ($shell =~ m/ksh$/ || $shell =~ m/zsh$/) {
      $logsw = ' -l';
    };
  };
  $colflt = ' | col -bx' if ($ColFilter);
  $Com =~ s/\"/\\\"/g;
  if ($Wait) {
      $output = `$shell$logsw -c \"$Com\"$colflt`;
  } else {
    if ($shell =~ m/csh$/) {
      open(PIPE,"$shell$logsw -c \"$Com \>\& /dev/null \&\"|");
    } else {
      open(PIPE,"$shell$logsw -c \"$Com \> /dev/null 2\>\&1 \&\"|");
#      open(PIPE,"$shell$logsw -c \"$Com &\> /dev/null \&\"|");
    };
    close(PIPE);
  };
  return $output;
}

sub GetUmask { # Sets WebRSH's umask to correspond to the shell's umask.

  local($umask) = &ExUShellCom('umask',$LoginShell,0,1);
  $umask =~ s/\n$//;
  $umask = join('','0',$umask);
  umask oct($umask);
}

sub ChangeDir { # Changes the working directory.

  local($dir) = @_;
  &WebrshDie("$dir is not a valid directory\!") if ($dir =~ m/^[\\\/][\\\/]/);
  $dir = "$dir\\" if ($dir =~ m/^\w\:$/ && $Win32);
  $dir = $ENV{'HOME'} if ($dir eq '~' && $ENV{'HOME'} && $OStype eq 'U');
  chdir $dir;
}

sub HtmlText { # Converts plain text to a format suitable for embedding in HTML.

  local($text) = @_;
  $text =~ s/\&/\&amp\;/g;
  $text =~ s/\</\&lt\;/g;
  $text =~ s/\>/\&gt\;/g;
  $text =~ s/\"/\&quot\;/g;
  return $text;
}

sub UrlChar { # Url-encodes a character (assumes characters above 0F).

  local($char) = @_;
  $char = join('','%',sprintf("%lx",unpack("c",$char)));
  $char =~ y/a-z/A-Z/;
  return $char;
}

sub UrlEncode { # Returns a url-encoded string (does not encode 00-0F control characters).

  local($string) = @_;
  $string =~ s/\%/\%25/g;
#  $string =~ s/\+/\%2B/g;
#  $string =~ s/ /\+/g;
#  $string =~ s/[^\x00-\x0f\!\"\$\%\'\(\)\*\+\-\.\w]/&UrlChar($&)/ge;
  $string =~ s/([^\x00-\x0f\!\"\$\%\'\(\)\*\-\.\w])/&UrlChar($1)/ge;
  return $string;
}

sub FullPath { # Returns the full path name for a file in a directory.

  local($directory,$file) = @_;
  local($path);
  if ($directory =~ m/[\\\/]$/) {
    $path = "$directory$file";
  } else {
    if ($Win32) {
      $path = "$directory\\$file";
    } else {
      $path = "$directory/$file";
    };
  };
  return $path;
}

sub FileName { # Extracts the name of the file from its full path name.

  local($name) = @_;
  $name =~ s/\\/\//g; 
  $name =~ s/(\W)/\\$1/g;
  $name =~ m/([^\/]+)$/;
  $name = $1;
  $name =~ s/\\//g;
  return $name;
}

sub DirName { # Extracts the name of the directory from the full path name of a file.

  local($name) = @_;
  $name =~ s/\\/\//g; 
  $name =~ s/(\W)/\\$1/g;
  $name =~ m/^(.+)\/([^\/]+)$/;
  $name = $1;
  $name =~ s/\\//g;
  $name =~ s/\//\\/g if ($Win32);
  return $name;
}

sub FileExt { # Returns the (capitalized) extension of a filename.

  local($filename) = @_;
  $filename =~ m/(\.[^\.]*$)/;
  local($ext) = $1;
  $ext =~ y/a-z/A-Z/;
  return $ext;
}
  
sub GetDirList { # Creates two arrays (a plain version and an url-encoded one) each of which   
                 # contains the list of directories in the current working directory. The 
                 # creation of the url-encoded array is suppressed if the function gets a
                 # true valued parameter.

  local($NoUrlEn) = @_;
  opendir(DIR,'.');
  @dirarray = sort grep -d && !/^\.\.?$/, readdir DIR;
  close DIR;
  unless ($NoUrlEn) {
    foreach $i (0..$#dirarray) {
      $ldirarray[$i] = &UrlEncode($dirarray[$i]);
    };
  };
}

sub GetFileList { # Creates two arrays (a plain version and an url-encoded one) each of which   
                  # contains the list of files in the current working directory. The creation
                  # of the url-encoded array is suppressed if the function gets a true valued
                  # parameter.

  local($NoUrlEn) = @_;
  opendir(DIR,'.');
  @filearray = sort grep -f, readdir DIR;
  close DIR;
  unless ($NoUrlEn) {
    foreach $i (0..$#filearray) {
      $lfilearray[$i] = &UrlEncode($filearray[$i]);
    };
  };
}

sub GetHTM { # Reads a text file in WebRSH's htm directory and returns its content.

  local($htmfile) = @_;
  local($buf,$content) = ('','');
  open(HTM, "<$ProgDir/htm/$htmfile") || WebrshDie("Can\'t open $htmfile \: $!");
  while (read(HTM,$buf,$BufSize)) {
    $content .= $buf;
  };
  close HTM;
  return $content;
}

sub ParseHTM { # Gets a text string as a parameter, replaces certain text constructs with
               # current values of appropriate WebRSH variables, and returns the result.

  local($output) = @_;
  $output =~ s/<\!\$BGColor\!>/$BGColor/g;
  $output =~ s/<\!\$BodyParam\!>/$BodyParam/g;
  $output =~ s/<\!\$TableColor\!>/$TableColor/g;
  $output =~ s/<\!\$FTableParam\!>/$FTableParam/g;
  $output =~ s/<\!\$TableParam\!>/$TableParam/g;
  $output =~ s/<\!\$ScriptUrl\!>/$ScriptUrl/g;
  $output =~ s/<\!\$SendFilesUrl\!>/$SendFilesUrl/g;
  $output =~ s/<\!\$counter\!>/$counter/g;
  $output =~ s/<\!\$id\!>/$id/g;
  $output =~ s/<\!\$lpwd\!>/$lpwd/g;
  $output =~ s/<\!\$plpwd\!>/$plpwd/g;
  return $output;
}

sub ContType { # Returns the MIME Content-type of a file based on its extension (according
               # to the correspondence set in the file Mimetable.txt).

  local($filename) = @_;
  local($ext,$cont,$fext,$fcont,$buf,*mtable);
  $fext = &FileExt($filename);
  open(MTABLE,"<$CfgDir/mimetable.txt") || &WebrshDie("Can\'t open MIME table: $!");
  while (read(MTABLE,$buf,$BufSize)) {
    $mtable .= $buf;
  };
  close(MTABLE);
  @mtable = split(/\n/,$mtable);
  local($i) = 0;
  while (!$fcont && $i <= $#mtable) {
    ($ext,$cont) = split(/\s+/,$mtable[$i],2);
    if ($ext eq $fext) {$fcont = $cont;};
    $i++;
  };
  unless ($fcont) {$fcont = $DefMimeType;};
  return $fcont;
}

sub SendFile { # Sends a file to the client, reporting its approriate Content-type.

  local($filename) = @_;
  local($buf,$cont,$clh) = ('','','');
  $! = 0;
  ((-f $filename) && open(FILE,"<$filename")) || &WebrshDie("Can\'t open $filename: $!");
  $cont = &ContType($filename);
  if ($GCLH) {$clh = join('','Content-length: ',-s $filename,"\n");};
  print "Content-type: $cont\n$clh\n";  
  binmode FILE;
  while (read(FILE,$buf,$BufSize)) {print $buf;};
  close FILE;
}

sub SendTextFile { # Sends a file to the client (optionally in text mode), reporting its 
                   # Content-type as text/plain.

  local($filename) = @_;
  local($buf,$clh,$bchar) = ('','','');
  $! = 0;
  ((-f $filename) && open(FILE,"<$filename")) || &WebrshDie("Can\'t open $filename: $!");
  if ($BinText) {
    binmode FILE;
    if ($GCLH) {$clh = join('','Content-length: ',-s $filename,"\n");};
  };
  print "Content-type: text/plain\n$clh\n";
  while (read(FILE,$buf,$BufSize)) {
    if (!$BinText && $OStype eq 'U') {
      if ($bchar ne "\r" && substr($buf,0,1) eq "\n") {
        $buf = join('',"\r",$buf);
      };
      $bchar = substr($buf,-1,1);
      $buf =~ s/([^\r])\n/$1\r\n/g;
    };
    print $buf;
  };
  close FILE;
}

sub SendBinFile { # Sends a file to the client, reporting its Content-type as
                  # application/octet-stream.

  local($filename) = @_;
  local($buf,$clh) = ('','');
  $! = 0;
  ((-f $filename) && open(FILE,"<$filename")) || &WebrshDie("Can\'t open $filename: $!");
  if ($GCLH) {$clh = join('','Content-length: ',-s $filename,"\n");};
  print "Content-type: application/octet-stream\n$clh\n";  
  binmode FILE;
  while (read(FILE,$buf,$BufSize)) {print $buf;};
  close FILE;
}

sub TextMode { # Executes a command and returns its output to the client as text/plain.

  local($tmcom) = @_;
  local($clh) = '';
  if ($Win32) {
    $output = &ExWin32Com($tmcom);
  } else {
    $output = &ExUShellCom($tmcom,$LoginShell,0,1);
  };
  if ($GCLH) {$clh = join('','Content-length: ',length($output),"\n");};  
  print "Content-type: text/plain\n$clh\n";  
  print $output;
}

sub RshStart { # Launches a file.

  local($file) = @_;
  close(STDERR);
  if ($OStype eq 'wNT') {
    $file = "\"$file\"" unless ($file =~ m/^\"/ || $file =~ m/\//);
    open(PIPE,"start \"RshStart\" $file|");
    close(PIPE);
  } elsif ($OStype eq 'w95') {
    $file = "\"$file\"" unless ($file =~ m/^\"/ || $file =~ m/\//);
    open(PIPE,"start $file|");
    close(PIPE);
  } elsif ($OStype eq 'U') {
     &ExUShellCom($file,$LoginShell,$ColFilter,0);
  };
}

#################################################################################################
# Subroutines to print html output:

sub PrintNull { # Prints the response to null (no $com) request.

  print '<HTML><HEAD><TITLE> WebRSH </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor\" $BodyParam",'>',"\n",
  '<CENTER><H1> Welcome to WebRSH </H1>',"\n",
  '<H4> You can use this program to execute commands on ',"$HostName",'</H4></CENTER>',"\n";
#  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
}

sub PrintCom { # Prints WebRSH's main (default) response.

  print '<HTML><HEAD><TITLE> WebRSH - Execution Report </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor\" $BodyParam",'><B> WebRSH: Your command ',"\'$com\'\n",
  ' had been executed </B>',"\n";
#  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  unless ($output) {print '<P> Your command did not generate any output </P>',"\n";}
  else {
    print '<BR> Your command generated the following output: <HR>',"\n",
    '<PRE>',&HtmlText($output),"\n",
    '</PRE>',"\n";
  }
}

sub PrintHTM { # Prints WebRSH html pages.

  if (!$output) {
    print '<HTML><HEAD><TITLE> WebRSH - HTM Problem </TITLE></HEAD>',"\n",
    '<BODY bgcolor="',"$BGColor\" $BodyParam",'>',"\n",
    '<B> WebRSH: HTM Problem: File appears to be empty </B>',"\n";
#    if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";}
    print '<P> Your command did not generate any output </P>',"\n";
  } else {
    print &ParseHTM($output),"\n";
  };
}

sub PrintWebRSHMainForm { # Prints WebRSH's main form.

  print '<CENTER><HR SIZE=6>',"\n";
  unless ($id =~ m/m/) {
    print '<H3>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshgethtm+mainhelp.htm"> [HELP]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshhome"> [HOME]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshfm"> [FM]</A>',"\n",
#    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=dir+%2FA+%2FW"> [DIR]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshps"> [PS]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshkilllist"> [KILL]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshlaunchlist"> [LAUNCH]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshexeclist"> [EXECUTE]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshgetlist"> [GET]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshuploadform"> [UPLOAD]</A>',"\n";
    if ($OStype eq 'wNT') {print
      '<A HREF="',"$ScriptUrl",'/rshplugin/',"$id$plpwd",'%3A%3A/services.pl"> [SERVICES]</A>',"\n";
    };
    print '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshoptions"> [OPTIONS]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshgethtm+more.htm"> [MORE]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'/rshplugin/',"$id$plpwd",'%3A%3A/LibPIframes.pl"> [FRAMES]</A>',"\n",
    '</H3><HR>',"\n";
  };
  print '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'" NAME="WebRSHMain">',"\n",
  '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
  '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n";
  unless ($id =~ m/c/) {
    print '<TABLE BGCOLOR="',"$TableColor\" $FTableParam",'>',"\n",
    '<TR><TD ALIGN="center">',"\n",
    '<TABLE ',"$TableParam",'><TR><TD ALIGN="center">',"\n",
    '<B> Working Directory is: ',"$pwd\n",'</B>',"\n",
    '</TD></TR><TR><TD ALIGN="center">',"\n",
    'COMMAND: <INPUT NAME="com"  SIZE="',"$ComFieldSize",'">',"\n",
    '</TD></TR><TR><TD ALIGN="center">',"\n",
    '<INPUT VALUE="       Execute       "  TYPE=submit>',"\n",
    '<INPUT VALUE=" Clear " TYPE=reset>',"\n",
    '</TD></TR></TABLE></TD></TR></TABLE><BR><HR>',"\n";
  };
  print '</FORM></CENTER>';
  unless ($id =~ m/v/) {print "\n$VerInf\n";};
}

# The following lines exist only to avoid warning messages

$SendFilesDir       =  $SendFilesDir;
$SendFilesUrl       =  $SendFilesUrl;
$MakeBack           =  $MakeBack;
$GetOptions         =  $GetOptions;
$FNFieldSize        =  $FNFieldSize;
$XPath              =  $XPath;
$FMSize             =  $FMSize;
$FMHSize            =  $FMHSize;
$EdCols             =  $EdCols;
$EdRows             =  $EdRows;
$EdWrap             =  $EdWrap;
$EdEmptyLnHldr      =  $EdEmptyLnHldr;
$EdTAMod            =  $EdTAMod;
$EdOPFL             =  $EdOPFL;
$EdHtmlText         =  $EdHtmlText;
$cgi_lib'writefiles =  $cgi_lib'writefiles;
$cgi_lib'bufsize    =  $cgi_lib'bufsize ;
$cgi_lib'maxdata    =  $cgi_lib'maxdata;
$CFileName          =  $CFileName;
$CContType          =  $CContType;
$lfilearray         =  $lfilearray;
$ldirarray          =  $ldirarray;

1; #return true 
